> This page is for Itential Platform On-Prem, version 6 (default).
> For other versions, use one of these documentation indexes:
> - 6 (default): https://docs-test.itntl.com/itential-platform/6/llms.txt
> - 2023.2: https://docs-test.itntl.com/itential-platform/2023-2/llms.txt

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs-test.itntl.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs-test.itntl.com/_mcp/server.

# Update an agent in a FlowAI project

PATCH https://example.itential.io/agent-project-service/agents/{agentId}
Content-Type: application/json

Updates an Agent Definition within a FlowAI Project. Requires editor or owner GBAC role; updating operators requires owner GBAC role.

Reference: https://docs-test.itntl.com/itential-platform/6/api-reference/agent-project-service/update-agent

## Authentication

- `Authorization` header (basic auth, required) — Basic authentication of the form `Basic <base64(username:password)>`.

## Request

### Path parameters

- `agentId` (string, required) — Agent _id (UUID).

### Body (application/json)

This endpoint expects an object.

- `name` (string, optional)
- `description` (string, optional)
- `prompt` (AgentProjectServiceAgentsAgentIdPatchRequestBodyContentApplicationJsonSchemaPrompt, optional)
- `provider` (AgentProjectServiceAgentsAgentIdPatchRequestBodyContentApplicationJsonSchemaProvider, optional)
- `addTools` (list of AgentProjectServiceAgentsAgentIdPatchRequestBodyContentApplicationJsonSchemaAddToolsItems, optional)
- `decorateTools` (list of AgentProjectServiceAgentsAgentIdPatchRequestBodyContentApplicationJsonSchemaDecorateToolsItems, optional)
- `authorizeTools` (list of AgentProjectServiceAgentsAgentIdPatchRequestBodyContentApplicationJsonSchemaAuthorizeToolsItems, optional)
- `removeTools` (list of AgentProjectServiceAgentsAgentIdPatchRequestBodyContentApplicationJsonSchemaRemoveToolsItems, optional)
- `operators` (list of string, optional)
- `addSkills` (list of AgentProjectServiceAgentsAgentIdPatchRequestBodyContentApplicationJsonSchemaAddSkillsItems, optional)
- `removeSkills` (list of AgentProjectServiceAgentsAgentIdPatchRequestBodyContentApplicationJsonSchemaRemoveSkillsItems, optional)

## Response

### 200

The updated Agent Definition

- `message` (string, required)
- `data` (AgentProjectServiceAgentsAgentIdPatchResponsesContentApplicationJsonSchemaData, required)

## Errors

### 500 Internal Server Error

Error response from API

- `any`

## Types

### AgentProjectServiceAgentsAgentIdPatchRequestBodyContentApplicationJsonSchemaPrompt

- `instructions` (string, required)
- `inputSchema` (AgentProjectServiceAgentsAgentIdPatchRequestBodyContentApplicationJsonSchemaPromptInputSchema, required)

### AgentProjectServiceAgentsAgentIdPatchRequestBodyContentApplicationJsonSchemaProvider

- `profile` (string, required)
- `model` (string, required)

### AgentProjectServiceAgentsAgentIdPatchRequestBodyContentApplicationJsonSchemaAddToolsItems

- `referenceId` (string, required)
- `decoratorId` (string, optional)

### AgentProjectServiceAgentsAgentIdPatchRequestBodyContentApplicationJsonSchemaDecorateToolsItems

- `referenceId` (string, required)
- `decoratorId` (string, required, nullable)

### AgentProjectServiceAgentsAgentIdPatchRequestBodyContentApplicationJsonSchemaAuthorizeToolsItems

- `referenceId` (string, required)

### AgentProjectServiceAgentsAgentIdPatchRequestBodyContentApplicationJsonSchemaRemoveToolsItems

- `referenceId` (string, required)

### AgentProjectServiceAgentsAgentIdPatchRequestBodyContentApplicationJsonSchemaAddSkillsItems

- `skillId` (string, required)
- `version` (integer, required)
- `latest` (boolean, optional, default: false)

### AgentProjectServiceAgentsAgentIdPatchRequestBodyContentApplicationJsonSchemaRemoveSkillsItems

- `skillId` (string, required)

### AgentProjectServiceAgentsAgentIdPatchResponsesContentApplicationJsonSchemaData

- `_id` (string, required)
- `name` (string, required)
- `description` (string, required)
- `instructions` (string, required)
- `inputSchema` (AgentProjectServiceAgentsAgentIdPatchResponsesContentApplicationJsonSchemaDataInputSchema, required)
- `created` (string, required)
- `createdBy` (AgentProjectServiceAgentsAgentIdPatchResponsesContentApplicationJsonSchemaDataCreatedBy, required)
- `lastUpdated` (string, required)
- `lastUpdatedBy` (AgentProjectServiceAgentsAgentIdPatchResponsesContentApplicationJsonSchemaDataLastUpdatedBy, required)
- `operators` (list of AgentProjectServiceAgentsAgentIdPatchResponsesContentApplicationJsonSchemaDataOperatorsItems, required)
- `namespace` (AgentProjectServiceAgentsAgentIdPatchResponsesContentApplicationJsonSchemaDataNamespace, required)
- `authorized` (boolean, required)
- `tools` (list of AgentProjectServiceAgentsAgentIdPatchResponsesContentApplicationJsonSchemaDataToolsItems, required)
- `skills` (list of AgentProjectServiceAgentsAgentIdPatchResponsesContentApplicationJsonSchemaDataSkillsItems, required)
- `provider` (AgentProjectServiceAgentsAgentIdPatchResponsesContentApplicationJsonSchemaDataProvider, optional, nullable)

### AgentProjectServiceAgentsAgentIdPatchRequestBodyContentApplicationJsonSchemaPromptInputSchema

- `type` (any, required)
- `additionalProperties` (any, required)
- `required` (list of string, required)
- `properties` (map from string to AgentProjectServiceAgentsAgentIdPatchRequestBodyContentApplicationJsonSchemaPromptInputSchema, required)

### AgentProjectServiceAgentsAgentIdPatchResponsesContentApplicationJsonSchemaDataInputSchema

### AgentProjectServiceAgentsAgentIdPatchResponsesContentApplicationJsonSchemaDataCreatedBy

- `_id` (string, required)
- `username` (string, required)
- `provenance` (string, required)

### AgentProjectServiceAgentsAgentIdPatchResponsesContentApplicationJsonSchemaDataLastUpdatedBy

- `_id` (string, required)
- `username` (string, required)
- `provenance` (string, required)

### AgentProjectServiceAgentsAgentIdPatchResponsesContentApplicationJsonSchemaDataOperatorsItems

- `_id` (string, required)
- `name` (string, required)
- `provenance` (string, required)

### AgentProjectServiceAgentsAgentIdPatchResponsesContentApplicationJsonSchemaDataNamespace

- `type` ("flowai_project", required)
- `_id` (string, required)
- `name` (string, required)

### AgentProjectServiceAgentsAgentIdPatchResponsesContentApplicationJsonSchemaDataToolsItems

### AgentProjectServiceAgentsAgentIdPatchResponsesContentApplicationJsonSchemaDataSkillsItems

- `skillId` (string, required)
- `version` (integer, required)
- `latest` (boolean, required)
- `lastKnownName` (string, required)

### AgentProjectServiceAgentsAgentIdPatchResponsesContentApplicationJsonSchemaDataProvider

- `profile` (string, required)
- `model` (string, required)
- `lastKnownProfileName` (string, required)
- `lastKnownModelName` (string, required)

### AgentProjectServiceAgentsAgentIdPatchResponsesContentApplicationJsonSchemaDataToolsItems0

- `referenceId` (string, required)
- `lastKnownName` (string, required)
- `decoratorId` (string, optional)

### AgentProjectServiceAgentsAgentIdPatchResponsesContentApplicationJsonSchemaDataToolsItems1

- `unauthorizedReferenceId` (string, required)
- `lastKnownName` (string, required)
- `decoratorId` (string, optional)

## Examples

**Request**

```json
{}
```

**Response**

```json
{
  "message": "string",
  "data": {
    "_id": "string",
    "name": "string",
    "description": "string",
    "instructions": "string",
    "inputSchema": {},
    "created": "2024-01-15T09:30:00Z",
    "createdBy": {
      "_id": "string",
      "username": "string",
      "provenance": "string"
    },
    "lastUpdated": "2024-01-15T09:30:00Z",
    "lastUpdatedBy": {
      "_id": "string",
      "username": "string",
      "provenance": "string"
    },
    "operators": [
      {
        "_id": "string",
        "name": "string",
        "provenance": "string"
      }
    ],
    "namespace": {
      "type": "string",
      "_id": "string",
      "name": "string"
    },
    "authorized": true,
    "tools": [
      {
        "decoratorId": "string",
        "lastKnownName": "string",
        "referenceId": "string"
      }
    ],
    "skills": [
      {
        "skillId": "string",
        "version": 1,
        "latest": true,
        "lastKnownName": "string"
      }
    ],
    "provider": null
  }
}
```

**SDK Code**

```python
import requests

url = "https://example.itential.io/agent-project-service/agents/agentId"

payload = {}
headers = {"Content-Type": "application/json"}

response = requests.patch(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://example.itential.io/agent-project-service/agents/agentId';
const options = {method: 'PATCH', headers: {'Content-Type': 'application/json'}, body: '{}'};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://example.itential.io/agent-project-service/agents/agentId"

	payload := strings.NewReader("{}")

	req, _ := http.NewRequest("PATCH", url, payload)

	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://example.itential.io/agent-project-service/agents/agentId")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Patch.new(url)
request["Content-Type"] = 'application/json'
request.body = "{}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.patch("https://example.itential.io/agent-project-service/agents/agentId")
  .header("Content-Type", "application/json")
  .body("{}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('PATCH', 'https://example.itential.io/agent-project-service/agents/agentId', [
  'body' => '{}',
  'headers' => [
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://example.itential.io/agent-project-service/agents/agentId");
var request = new RestRequest(Method.PATCH);
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = ["Content-Type": "application/json"]
let parameters = [] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://example.itential.io/agent-project-service/agents/agentId")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "PATCH"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```